The DragonSpark Framework
=========================

The DragonSpark Framework is an application development accelerator for Xaml-based application services and HTML5 clients.

This framework features a robust infrastructure for defining and configuring your application services with Xaml-based functionality, while developing your clients with HTML5 and JavaScript. 

In effect, components are defined in Xaml on the server side, and then serialized as JSON and sent to the client via ASP.NET WebAPI controllers.

A deployed featureset application hosted on Windows Azure may be found here:
http://framework.dragonspark.us/

Feature-Set
The DragonSpark Application Framework addresses these key application and system development friction points:
- Application Initialization
- Application Configuration (Xaml-Driven IoC and WebApi Controller Configuration)
- Synchronous Web Service Calls in Silverlight (via T4-generated Service Proxies)
- Operation Management and User Experience
- Exception Handling, Reporting and User Experience
- Authentication
- Authorization
- Navigation
- User Profile Management
- Entity Installation (Versioned Xaml-Driven Database seeding -- no more Sql Scripts)
- Entity Management
